import { Connection } from "./connection";
export declare class JsStoreMap {
    private con;
    constructor(con: Connection);
    /**
     * Returns the value associated to the passed key, or undefined if there is none.
     *
     * @template T
     * @param {string} key
     * @return {*}
     * @memberof JsStoreMap
     */
    get<T>(key: string): Promise<T>;
    /**
     * Returns a boolean indicating whether a value has been associated with the passed key in the MapStore or not.
     *
     * @param {string} key
     * @return {*}
     * @memberof JsStoreMap
     */
    has(key: string): Promise<boolean>;
    /**
     * Sets the value for the passed key in the map store
     *
     * @param {string} key
     * @param {*} value
     * @return {*}
     * @memberof JsStoreMap
     */
    set(key: string, value: any): Promise<void>;
    /**
     * delete the value by key in the map store
     *
     * @param {string} key
     * @return {*}
     * @memberof JsStoreMap
     */
    delete(key: string): Promise<void>;
}
